// Created by John Liaperdos and George Theophanous, July 2015

var connector_ids=['a0','a1','b0','b1','c0','c1','d0','d1','e0','e1','f0','f1','g0','g1','gnd0','gnd1','nc0','nc1'];

var solution=[];
// solutions format: [a0,a1,b0,b1 ... g0,g1,gnd0,gnd1,nc0,nc1]
	solution[0]=[0,1,0,1,0,1,0,1,0,1,0,1,1,0,1,0,0,0];
	solution[1]=[1,0,0,1,0,1,1,0,1,0,1,0,1,0,1,0,0,0];
	solution[2]=[0,1,0,1,1,0,0,1,0,1,1,0,0,1,1,0,0,0];
	solution[3]=[0,1,0,1,0,1,0,1,1,0,1,0,0,1,1,0,0,0];
	solution[4]=[1,0,0,1,0,1,1,0,1,0,0,1,0,1,1,0,0,0];
	solution[5]=[0,1,1,0,0,1,0,1,1,0,0,1,0,1,1,0,0,0];
	solution[6]=[0,1,1,0,0,1,0,1,0,1,0,1,0,1,1,0,0,0];
	solution[7]=[0,1,0,1,0,1,1,0,1,0,1,0,1,0,1,0,0,0];
	solution[8]=[0,1,0,1,0,1,0,1,0,1,0,1,0,1,1,0,0,0];
	solution[9]=[0,1,0,1,0,1,0,1,1,0,0,1,0,1,1,0,0,0];
	
var current_combination=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0];
var number_to_display=2;

function initializeSevenSegmentDisplay(){
	document.getElementById('target_number_text').textContent=number_to_display;
}

function showNewNumber(){
	resetConnections();
	document.getElementById('target_number_text').style.fill='blue';
	if(number_to_display<9)
	{
		number_to_display=number_to_display+1;
	}
	else
	{
		number_to_display=0;
	}
	document.getElementById('target_number_text').textContent=number_to_display;
}

function resetConnections(){
	clearDisplay();
	document.getElementById('target_number_text').style.fill='blue';
	current_combination=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0];
	for (var i = 0; i < connector_ids.length; i++) {	
		document.getElementById(connector_ids[i]).setAttribute('style', 'fill:white;stroke:black;');
	};
}

function toggleConnection(connector_id){
	clearDisplay();
	connector_object=document.getElementById(connector_id);
	document.getElementById('target_number_text').style.fill='blue';
	connection_index=connector_ids.indexOf(connector_id);
	if(current_combination[connection_index]==0)
	{
		//connect
		current_combination[connection_index]=1;
		connector_object.setAttribute('style', 'fill:black;stroke:black;');
	}
	else
	{
		//disconnect
		current_combination[connection_index]=0;
		connector_object.setAttribute('style', 'fill:white;stroke:black;');
	}
}

function checkSolution(){
	if(compareResults(solution[number_to_display],current_combination))
	{
		document.getElementById('target_number_text').style.fill='green';
		lightDisplay(number_to_display);
	}
	else
	{
		document.getElementById('target_number_text').style.fill='red';
	}
}

function compareResults(solution_array,user_solution_array){
	arrays_equal=true;
	for (var i = 0; i < solution_array.length; i++) {	
		if(solution_array[i]!=user_solution_array[i])
		{
			arrays_equal=false;
			break;
		}
	};
	return arrays_equal;
}

function lightDisplay(number_value){
	for (var i = 1; i <=13; i=i+2) {	
		if(current_combination[i]==1)
		{
			document.getElementById(connector_ids[i].substr(0,1)+'_segment').style.fill='red';
		}
	};
}

function clearDisplay(){
	document.getElementById('a_segment').style.fill='none';
	document.getElementById('b_segment').style.fill='none';
	document.getElementById('c_segment').style.fill='none';
	document.getElementById('d_segment').style.fill='none';
	document.getElementById('e_segment').style.fill='none';
	document.getElementById('f_segment').style.fill='none';
	document.getElementById('g_segment').style.fill='none';
}